using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Contabilidad._3_Vistas.Controladoras;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Controles.ControlesAuxiliares;
using Exferia_Formularios;
using Exferia_Contabilidad.General;

namespace Exferia_Contabilidad._3_Vistas
{
    public partial class P_InformeContableLinea : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_InformeContableLinea_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();

        //Desglose
        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE = null;

        //Acumulado
        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO = null;
        #endregion

        #region Objetos en Pantalla

        //Exferia_BarraProgreso
        internal Exferia_BarraProgreso Exferia_BarraProgreso_Desglose { get { return ex_pgb_InformeContableLinea_BarraProgreso_Desglose; } }
        internal Exferia_BarraProgreso Exferia_BarraProgreso_Acumulado { get { return ex_pgb_InformeContableLinea_BarraProgreso_Acumulado; } }

        //Exferia_Button
        internal Exferia_Button Exferia_Button_Desglose_Add { get { return ex_btn_P_InformeContableLinea_Desglose_Add; } }
        internal Exferia_Button Exferia_Button_Desglose_Ver { get { return ex_btn_P_InformeContableLinea_Desglose_Ver; } }
        internal Exferia_Button Exferia_Button_Desglose_Filtros { get { return ex_btn_P_InformeContableLinea_Desglose_Filtros; } }
        internal Exferia_Button Exferia_Button_Desglose_Delete { get { return ex_btn_P_InformeContableLinea_Desglose_Borrar; } }
        internal Exferia_Button Exferia_Button_Acumulado_Add { get { return ex_btn_P_InformeContableLinea_Acumulado_Add; } }
        internal Exferia_Button Exferia_Button_Acumulado_Ver { get { return ex_btn_P_InformeContableLinea_Acumulado_Ver; } }
        internal Exferia_Button Exferia_Button_Acumulado_Filtros { get { return ex_btn_P_InformeContableLinea_Acumulado_Filtros; } }
        internal Exferia_Button Exferia_Button_Acumulado_Delete { get { return ex_btn_P_InformeContableLinea_Acumulado_Borrar; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_Especial { get { return ex_cbo_P_InformeContableLinea_Especial; } }
        internal Exferia_ComboBox Exferia_ComboBox_NivelTitulo { get { return ex_cbo_P_InformeContableLinea_NivelTitulo; } }

        //Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Desglose { get { return ex_dgv_P_InformeContableLinea_Desglose; } }
        internal Exferia_DataGridView Exferia_DataGridView_Acumulado { get { return ex_dgv_P_InformeContableLinea_Acumulado; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Descripcion { get { return ex_lbl_P_InformeContableLinea_Descripcion; } }
        internal Exferia_Label Exferia_Label_Linea { get { return ex_lbl_P_InformeContableLinea_Linea; } }
        internal Exferia_Label Exferia_Label_Espacios { get { return ex_lbl_P_InformeContableLinea_Espacios; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_InformesContablesLineas { get { return ex_Paginador; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Descripcion { get { return ex_txt_P_InformeContableLinea_Descripcion; } }
        internal Exferia_TextBox Exferia_TextBox_Linea { get { return ex_txt_P_InformeContableLinea_Linea; } }
        internal Exferia_TextBox Exferia_TextBox_Espacios { get { return ex_txt_P_InformeContableLinea_Espacios; } }
        internal Exferia_TextBox Exferia_TextBox_ControlSigno { get { return ex_txt_P_InformeContableLinea_ControlSigno; } }

        //Panel
        internal Panel Panel_NivelTitulo { get { return pnl_P_InformeContableLinea_NivelTitulo; } }
        
        #endregion

        #region Constructor
        public P_InformeContableLinea(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                     DateTime _dtt_FechaTrabajo,
                                     PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle,
                                     CTA_InformesContablesCabecera _mdl_CTA_InformesContablesCabecera)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Datos de la Cabecera
                ex_lbl_P_InformeContableLinea_DatosCabecera.Text = _mdl_CTA_InformesContablesCabecera.descripcion;

                //Instanciar Controladora
                g_obj_Controladora = new P_InformeContableLinea_Controladora(this, _mdl_CTA_InformesContablesCabecera);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura ..........................
                ex_btn_P_InformeContableLinea_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_InformeContableLinea_Grabar.Exferia_Button_Bloqueable = false;
                //.................................................................................................

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Desglose
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }

                    //Acumulado
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }
                }

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_InformeContableLinea) + "/" + nameof(P_InformeContableLinea));
                    }
                }
                //....................................................................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();


                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_InformeContableLinea) + "/" + nameof(P_InformeContableLinea));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto ....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_InformeContableLinea_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
                #endregion

                #region DESGLOSE

                //Crear Columnas Listado
                CrearColumnas_Listado_Desglose();
                #endregion

                #region ACUMULADO

                //Crear Columnas Listado
                CrearColumnas_Listado_Acumulado();
                #endregion
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_InformeContableLinea) + "/" + nameof(P_InformeContableLinea_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_InformeContableLinea_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + "- Añadir";

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        Funciones.Poner_Foco_Objeto(this, ex_txt_P_InformeContableLinea_Descripcion);

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_InformesContablesLineas.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_InformesContablesLineas.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_InformeContableLinea) + "/" + nameof(P_InformeContableLinea_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_InformesContablesLineas.Visible)
            {
                Exferia_Paginador_InformesContablesLineas.Visible = _bol_Activar;
            }

            if (ex_btn_P_InformeContableLinea_Borrar.Enabled)
            {
                ex_btn_P_InformeContableLinea_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_INSERTAR) ||
                        _enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_MODIFICAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //INFORMESCONTABLESLINEADESGLOSE
                        if (obj_Opcion.Equals(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE))
                        {
                            g_obj_Controladora.Actualizar_UltimosRegistrosModificados_Listado_Desglose((long)lst_obj[1]);
                        }
                        //INFORMESCONTABLESLINEAACUMULADO
                        else if (obj_Opcion.Equals(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO))
                        {
                            g_obj_Controladora.Actualizar_UltimosRegistrosModificados_Listado_Acumulado((long)lst_obj[1]);
                        }
                    }
                    else if (_enum_TipoAccion.Equals(G_ENUM_TIPOACCION.INT_ELIMINAR))
                    {
                        List<object> lst_obj = (List<object>)_obj;
                        string obj_Opcion = (string)lst_obj[0];

                        //INFORMESCONTABLESLINEADESGLOSE
                        if (obj_Opcion.Equals(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE))
                        {
                            g_obj_Controladora.Actualizar_UltimosRegistrosModificados_Listado_Desglose((long)lst_obj[1]);
                        }
                        //INFORMESCONTABLESLINEAACUMULADO
                        else if (obj_Opcion.Equals(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO))
                        {
                            g_obj_Controladora.Actualizar_UltimosRegistrosModificados_Listado_Acumulado((long)lst_obj[1]);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Mensajes.MostrarMensaje(ex.Message);
            }
        }

        #region Botones Grabar,Borrar
        private void ex_btn_P_InformeContableLinea_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                    
                //Añadiendo
                if (this.P_Base_TipoAperturaPantalla == 0)
                {
                    g_obj_Controladora.GrabarDatos(true, false);
                }
                //Modificando
                else
                {
                    g_obj_Controladora.GrabarDatos(false, false);
                }
            }
        }

        private void ex_btn_P_InformeContableLinea_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(); 
            }
        }

        #endregion

        #region Linea Especial
        private void ex_cbo_P_InformeContableLinea_Especial_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if (g_obj_Controladora != null && g_obj_Controladora.g_bol_TareaAsincrona_CargarDatos_Termino)
                {
                    if (ex_cbo_P_InformeContableLinea_Especial.SelectedItem != null &&
                        (
                            ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_TITULO.Codigo) ||
                            ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_SALTALINEA.Codigo))
                        )
                    {
                        pnl_P_InformeContableLinea_NivelTitulo.Visible = true;
                    }
                    else
                    {
                        pnl_P_InformeContableLinea_NivelTitulo.Visible = false;

                        ex_txt_P_InformeContableLinea_Descripcion.Text = ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).ObjetoAuxiliar_1.ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_InformeContableLinea) + "/" + nameof(ex_cbo_P_InformeContableLinea_Especial_SelectedIndexChanged));
            }
        }
        #endregion

        #region Control Signo
        private void ex_txt_P_InformeContableLinea_ControlSigno_Exferia_TextBox_Evento_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsDigit(e.KeyChar))
            {
                if (e.KeyChar.ToString().Equals("1"))
                {
                    ex_txt_P_InformeContableLinea_ControlSigno.Text = "";
                    e.KeyChar = (char)68;
                }
                else if (e.KeyChar.ToString().Equals("2"))
                {
                    ex_txt_P_InformeContableLinea_ControlSigno.Text = "";
                    e.KeyChar = (char)72;
                }
                else if (char.IsControl(e.KeyChar)) //permitir teclas de control como retroceso 
                {
                    e.Handled = false;
                }
                else
                {
                    e.Handled = true;
                    return;
                }
            }
            //Otros Simbolos
            else
            {
                if (e.KeyChar.ToString().Equals("D") || e.KeyChar.ToString().Equals("d"))
                {
                    ex_txt_P_InformeContableLinea_ControlSigno.Text = "";
                    e.KeyChar = (char)68;
                }
                else if (e.KeyChar.ToString().Equals("H") || e.KeyChar.ToString().Equals("h"))
                {
                    ex_txt_P_InformeContableLinea_ControlSigno.Text = "";
                    e.KeyChar = (char)72;
                }
                else if (char.IsControl(e.KeyChar)) //permitir teclas de control como retroceso 
                {
                    e.Handled = false;
                }
                else
                {
                    e.Handled = true;
                    return;
                }
            }

            Controlar_Modificaciones();
           
        }
        #endregion

        #region Desglose
        private void CrearColumnas_Listado_Desglose()
        {
            ex_dgv_P_InformeContableLinea_Desglose.AutoGenerateColumns = false;

            List<INTERNO_ABS_Listado_ColumnasDatos_Modelo> lst_ListadoCampos = g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in lst_ListadoCampos)
            {
                dynamic dgv_Columna = null;

                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.BOTON))
                {
                    dgv_Columna = new DataGridViewButtonColumn();
                }
                else
                {
                    dgv_Columna = new DataGridViewTextBoxColumn();
                }
                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE != null &&
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNASAMOSTRAR != null &&
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;

                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar_DESGLOSE.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }

                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................

                dgv_Columna.ReadOnly = true;

                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_P_InformeContableLinea_Desglose.Columns.Add(dgv_Columna);
            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESDESGLOSE.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_P_InformeContableLinea_Desglose.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        #region Botones
        private void ex_btn_P_InformeContableLinea_Desglose_Filtros_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Fitros_Desglose(ex_btn_P_InformeContableLinea_Desglose_Filtros.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Fitros_Desglose(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE, ex_dgv_P_InformeContableLinea_Desglose.Columns, g_obj_Controladora.g_dct_ListadoFiltros_DESGLOSE);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar_DESGLOSE = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_P_InformeContableLinea_Desglose.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar_DESGLOSE.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }
                //Rellenar los nuevos filtros
                g_obj_Controladora.g_dct_ListadoFiltros_DESGLOSE = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                //Cambiar Imagen de Filtros , si tiene o no
                if (g_obj_Controladora.g_dct_ListadoFiltros_DESGLOSE != null && g_obj_Controladora.g_dct_ListadoFiltros_DESGLOSE.Count > 0)
                {
                    ex_btn_P_InformeContableLinea_Desglose_Filtros.Exferia_Button_Imagen = Imagenes.G_ENUM_IMAGENES.G_IMG_FILTROS_TIENE;
                }
                else
                {
                    ex_btn_P_InformeContableLinea_Desglose_Filtros.Exferia_Button_Imagen = Imagenes.G_ENUM_IMAGENES.G_IMG_FILTROS;
                }
                Imagenes.Asignar_Imagen(ex_btn_P_InformeContableLinea_Desglose_Filtros);

                //Recargar el Listado
                g_obj_Controladora.Rellenar_DataGrid_Desglose();

            }
        }

        private void ex_btn_P_InformeContableLinea_Desglose_Add_Click(object sender, EventArgs e)
        {
            Add_Desglose();
        }
        private void Add_Desglose()
        {
            //Solo se puede añadir desglose al tipo de linea titulo y salto de linea
            if (ex_cbo_P_InformeContableLinea_Especial.SelectedItem != null &&
                (
                    ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_TITULO.Codigo) ||
                    ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_SALTALINEA.Codigo))
                )
            {
                //Añadir
                if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)))
                {
                    //Saber si hay que guardar primero la linea
                    if (g_obj_Controladora.ComprobarCambios_AfectaLineas())
                    {
                        //Poner el Listado para el paginado ....................................................
                        List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = g_obj_Controladora.Filtrar_DESGLOSE();
                        if (lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo != null && lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Count > 0)
                        {
                            lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.OrderBy(m => m.linea).ToList();

                            P_Base_Objetos_Filtrados = lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                        }
                        else
                        {
                            P_Base_Objetos_Filtrados = null;
                        }
                        //......................................................................................


                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE);

                        //Buscar Opciones Modelo
                        P_InformeContableDesglose frm_P_InformeContableDesglose = new P_InformeContableDesglose(P_Base_ValoresGenerales,
                                                                                                                P_Base_FechaTrabajo,
                                                                                                                mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesCabecera,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.id,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.linea,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.descripcion,
                                                                                                                P_Base_PantallaOrigen);

                        //Se llamo desde una pantalla
                        frm_P_InformeContableDesglose.P_Base_TipoAperturaPantalla = 0;
                        frm_P_InformeContableDesglose.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_InformeContableDesglose.P_Base_PantallaOrigen = this;
                        frm_P_InformeContableDesglose.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_InformeContableDesglose, Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE);
                    }
                }
            }
            else
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_INFORMESCONTABLES_VALIDACION_DEBESELECCIONAR_TIPOCAMBOPESPECIAL_CORRECTO("Desglose"));
            }

        }

        private void ex_btn_P_InformeContableLinea_Desglose_Ver_Click(object sender, EventArgs e)
        {
            Ver_Desglose();
        }
        private void ex_dgv_P_InformeContableLinea_Desglose_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Desglose();
        }
        private void Ver_Desglose()
        {
            if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true)))
            {
                
                //Ver si hay alguno seleccionado
                if (ex_dgv_P_InformeContableLinea_Desglose.Rows.Count > 0 && ex_dgv_P_InformeContableLinea_Desglose.SelectedRows.Count > 0)
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE);

                    //Poner el Listado para el paginado ....................................................
                    List<INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = g_obj_Controladora.Filtrar_DESGLOSE();
                    if (lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo != null && lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Count > 0)
                    {
                        lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo = lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.OrderBy(m => m.linea).ToList();

                        P_Base_Objetos_Filtrados = lst_INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                    }
                    else
                    {
                        P_Base_Objetos_Filtrados = null;
                    }
                    //......................................................................................


                    //Buscar Opciones Modelo
                    P_InformeContableDesglose frm_P_InformeContableDesglose = new P_InformeContableDesglose(P_Base_ValoresGenerales,
                                                                                                    P_Base_FechaTrabajo,
                                                                                                    mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesCabecera,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.id,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.linea,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.descripcion,
                                                                                                    P_Base_PantallaOrigen);

                    //Se llamo desde una pantalla
                    frm_P_InformeContableDesglose.P_Base_TipoAperturaPantalla = 1;
                    frm_P_InformeContableDesglose.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_InformeContableDesglose.P_Base_PantallaOrigen = this;
                    frm_P_InformeContableDesglose.P_Base_id = long.Parse(ex_dgv_P_InformeContableLinea_Desglose.SelectedRows[0].Cells[0].Value.ToString());
                    frm_P_InformeContableDesglose.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_InformeContableDesglose, Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE);

                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
                
            }
        }

        private void ex_btn_P_InformeContableLinea_Desglose_Delete_Click(object sender, EventArgs e)
        {
            Borrar_Desglose();
        }
        private void Borrar_Desglose()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEADESGLOSE, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                //Ver si hay algunbo seleccionado
                if (ex_dgv_P_InformeContableLinea_Desglose.Rows.Count > 0 && ex_dgv_P_InformeContableLinea_Desglose.SelectedRows.Count > 0)
                {
                    List<long> lst_ids_Seleccionados = new List<long>();
                    foreach (DataGridViewRow dgvr in ex_dgv_P_InformeContableLinea_Desglose.SelectedRows)
                    {
                        lst_ids_Seleccionados.Add(long.Parse(dgvr.Cells[nameof(INTERNO_CTA_InformesContablesLineaDesglose_Listado_Modelo.id)].Value.ToString()));
                    }

                    g_obj_Controladora.BorrarDatos_Desglose(lst_ids_Seleccionados);
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_P_InformeContableLinea_Desglose_Actualizar_Click(object sender, EventArgs e)
        {
            Actualizar_Desglose();
        }
        private void Actualizar_Desglose()
        {
            if (g_obj_Controladora != null)
            {
                g_obj_Controladora.Cargar_Listado_Desde_BD_Desglose();
            }
        }

        #endregion

        #endregion

        #region Acumulado
        private void CrearColumnas_Listado_Acumulado()
        {
            ex_dgv_P_InformeContableLinea_Acumulado.AutoGenerateColumns = false;

            List<INTERNO_ABS_Listado_ColumnasDatos_Modelo> lst_ListadoCampos = g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in lst_ListadoCampos)
            {
                dynamic dgv_Columna = null;

                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.BOTON))
                {
                    dgv_Columna = new DataGridViewButtonColumn();
                }
                else
                {
                    dgv_Columna = new DataGridViewTextBoxColumn();
                }
                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO != null &&
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNASAMOSTRAR != null &&
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;

                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar_ACUMULADO.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }

                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................

                dgv_Columna.ReadOnly = true;

                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_P_InformeContableLinea_Acumulado.Columns.Add(dgv_Columna);
            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INFORMESCONTABLESACUMULADO.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_P_InformeContableLinea_Acumulado.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        #region Botones
        private void ex_btn_P_InformeContableLinea_Acumulado_Filtros_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Fitros_Acumulado(ex_btn_P_InformeContableLinea_Acumulado_Filtros.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Fitros_Acumulado(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO, ex_dgv_P_InformeContableLinea_Acumulado.Columns, g_obj_Controladora.g_dct_ListadoFiltros_ACUMULADO);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar_ACUMULADO = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_P_InformeContableLinea_Acumulado.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar_ACUMULADO.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }
                //Rellenar los nuevos filtros
                g_obj_Controladora.g_dct_ListadoFiltros_ACUMULADO = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                //Cambiar Imagen de Filtros , si tiene o no
                if (g_obj_Controladora.g_dct_ListadoFiltros_ACUMULADO != null && g_obj_Controladora.g_dct_ListadoFiltros_ACUMULADO.Count > 0)
                {
                    ex_btn_P_InformeContableLinea_Acumulado_Filtros.Exferia_Button_Imagen = Imagenes.G_ENUM_IMAGENES.G_IMG_FILTROS_TIENE;
                }
                else
                {
                    ex_btn_P_InformeContableLinea_Acumulado_Filtros.Exferia_Button_Imagen = Imagenes.G_ENUM_IMAGENES.G_IMG_FILTROS;
                }
                Imagenes.Asignar_Imagen(ex_btn_P_InformeContableLinea_Acumulado_Filtros);

                //Recargar el Listado
                g_obj_Controladora.Rellenar_DataGrid_Acumulado();

            }
        }

        private void ex_btn_P_InformeContableLinea_Acumulado_Add_Click(object sender, EventArgs e)
        {
            Add_Acumulado();
        }
        private void Add_Acumulado()
        {
            //Solo se puede añadir desglose al tipo de linea titulo y salto de linea
            if (ex_cbo_P_InformeContableLinea_Especial.SelectedItem != null &&
                (
                    ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_TITULO.Codigo) ||
                    ((INTERNO_ComboBox_Modelo)ex_cbo_P_InformeContableLinea_Especial.SelectedItem).Identificador.Equals(Variables_Contabilidad.G_MDL_INFORMECONTABLECAMPOESPECIAL_SALTALINEA.Codigo))
                )
            {
                //Añadir
                if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)))
                {
                    //Saber si hay que guardar primero la linea
                    if (g_obj_Controladora.ComprobarCambios_AfectaLineas())
                    {
                        //Poner el Listado para el paginado ....................................................
                        List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = g_obj_Controladora.Filtrar_ACUMULADO();
                        if (lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo != null && lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.Count > 0)
                        {
                            lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.OrderBy(m => m.linea).ToList();

                            P_Base_Objetos_Filtrados = lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                        }
                        else
                        {
                            P_Base_Objetos_Filtrados = null;
                        }
                        //......................................................................................


                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO);

                        //Buscar Opciones Modelo
                        P_InformeContableAcumulado frm_P_InformeContableAcumulado = new P_InformeContableAcumulado(P_Base_ValoresGenerales,
                                                                                                                P_Base_FechaTrabajo,
                                                                                                                mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesCabecera,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.id,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.linea,
                                                                                                                g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.descripcion,
                                                                                                                P_Base_PantallaOrigen);

                        //Se llamo desde una pantalla
                        frm_P_InformeContableAcumulado.P_Base_TipoAperturaPantalla = 0;
                        frm_P_InformeContableAcumulado.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                        frm_P_InformeContableAcumulado.P_Base_PantallaOrigen = this;
                        frm_P_InformeContableAcumulado.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                        Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_InformeContableAcumulado, Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO);
                    }
                }
            }
            else
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_INFORMESCONTABLES_VALIDACION_DEBESELECCIONAR_TIPOCAMBOPESPECIAL_CORRECTO("Acumulado"));
            }
        }

        private void ex_btn_P_InformeContableLinea_Acumulado_Ver_Click(object sender, EventArgs e)
        {
            Ver_Acumulado();
        }
        private void ex_dgv_P_InformeContableLinea_Acumulado_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_Acumulado();
        }
        private void Ver_Acumulado()
        {
            if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true)))
            {

                //Ver si hay alguno seleccionado
                if (ex_dgv_P_InformeContableLinea_Acumulado.Rows.Count > 0 && ex_dgv_P_InformeContableLinea_Acumulado.SelectedRows.Count > 0)
                {
                    INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO);

                    //Poner el Listado para el paginado ....................................................
                    List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = g_obj_Controladora.Filtrar_ACUMULADO();
                    if (lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo != null && lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.Count > 0)
                    {
                        lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.OrderBy(m => m.linea).ToList();

                        P_Base_Objetos_Filtrados = lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                    }
                    else
                    {
                        P_Base_Objetos_Filtrados = null;
                    }
                    //......................................................................................


                    //Buscar Opciones Modelo
                    P_InformeContableAcumulado frm_P_InformeContableAcumulado = new P_InformeContableAcumulado(P_Base_ValoresGenerales,
                                                                                                    P_Base_FechaTrabajo,
                                                                                                    mdl_INTERNO_OpcionesDetalle_Modelo,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesCabecera,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.id,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.linea,
                                                                                                    g_obj_Controladora.g_mdl_CTA_InformesContablesLinea.descripcion,
                                                                                                    P_Base_PantallaOrigen);

                    //Se llamo desde una pantalla
                    frm_P_InformeContableAcumulado.P_Base_TipoAperturaPantalla = 1;
                    frm_P_InformeContableAcumulado.P_Base_PantallaPadre_IdentificadorTAG = this.Tag.ToString();
                    frm_P_InformeContableAcumulado.P_Base_PantallaOrigen = this;
                    frm_P_InformeContableAcumulado.P_Base_id = long.Parse(ex_dgv_P_InformeContableLinea_Acumulado.SelectedRows[0].Cells[0].Value.ToString());
                    frm_P_InformeContableAcumulado.P_Base_TituloPantalla_CaminoHormigas = mdl_INTERNO_OpcionesDetalle_Modelo.descripcion_TituloMantenimiento.ToUpper() + " -> Alta";

                    Funciones_PanelPrincipal.Cargar_PantallaEmpotrada(frm_P_InformeContableAcumulado, Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO);

                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }

            }
        }

        private void ex_btn_P_InformeContableLinea_Acumulado_Delete_Click(object sender, EventArgs e)
        {
            Borrar_Acumulado();
        }
        private void Borrar_Acumulado()
        {
            if (Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_CTA_INFORMESCONTABLESLINEAACUMULADO, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                //Ver si hay algunbo seleccionado
                if (ex_dgv_P_InformeContableLinea_Acumulado.Rows.Count > 0 && ex_dgv_P_InformeContableLinea_Acumulado.SelectedRows.Count > 0)
                {
                    List<long> lst_ids_Seleccionados = new List<long>();
                    foreach (DataGridViewRow dgvr in ex_dgv_P_InformeContableLinea_Acumulado.SelectedRows)
                    {
                        lst_ids_Seleccionados.Add(long.Parse(dgvr.Cells[nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.id)].Value.ToString()));
                    }

                    g_obj_Controladora.BorrarDatos_Acumulado(lst_ids_Seleccionados);
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_LISTADOS_NOHAYREGISTROSSELECCIONADOS());
                }
            }
        }

        private void ex_btn_P_InformeContableLinea_Acumulado_Actualizar_Click(object sender, EventArgs e)
        {
            Actualizar_Acumulado();
        }
        private void Actualizar_Acumulado()
        {
            if (g_obj_Controladora != null)
            {
                g_obj_Controladora.Cargar_Listado_Desde_BD_Acumulado();
            }
        }

        #endregion

        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_InformesContablesLineas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_InformesContablesLineas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_InformesContablesLineas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_InformesContablesLineas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_InformesContablesLineas.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_InformesContablesLineas.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }

        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }


        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        private void P_InformeContableLinea_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {

                #region DESGLOSE
                //Guardar el fichero xml de configuracion de la pantalla
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE = new INTERNO_ConfiguracionPantalla_Modelo();
                Dictionary<string, int> dct_ColumnasOrden_DESGLOSE = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_DESGLOSE = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_P_InformeContableLinea_Desglose.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_DESGLOSE.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_DESGLOSE.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar_DESGLOSE;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_DESGLOSE;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_DESGLOSE;

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_DESGLOSE.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_DESGLOSE);
                }
                #endregion

                #region ACUMULADO
                //Guardar el fichero xml de configuracion de la pantalla
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO = new INTERNO_ConfiguracionPantalla_Modelo();
                Dictionary<string, int> dct_ColumnasOrden_ACUMULADO = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_ACUMULADO = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_P_InformeContableLinea_Acumulado.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_ACUMULADO.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_ACUMULADO.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar_ACUMULADO;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_ACUMULADO;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_ACUMULADO;

                //Actualizar la Variables General
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_ACUMULADO.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_ACUMULADO);
                }
                #endregion


            }
            catch (Control_Errores)
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_InformeContableLinea) + "/" + nameof(P_InformeContableLinea_FormClosed));
            }
        }
    }
}
